﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace FirstThread
{
    class Program
    {
        static void Main()
        {
            //MainSimplest();
            //Main4Threads();
            //Main4ThreadsMessage();
            //Main4ThreadsMessage();
            //Main4ThreadsNameJoinPriority();
            MainPool();
        }

        private static void MainPool()
        {
            Task.Run(() => Print("aaa", 4));
            Task.Run(() => Print("bbbb", 4));
            Console.ReadLine();
            // background threads are killed when the foreground thread (main) is done.
            // That is why we need Console.ReadLine() to pause the main.
        }

        private static void Main4ThreadsNameJoinPriority()
        {
            Thread thread1 = new Thread(() => PrintWithName("first", 4));
            thread1.Name = "First thread";
            thread1.Priority = ThreadPriority.Highest;
            thread1.Start();

            Thread thread2 = new Thread(() => PrintWithName("second", 10));
            thread2.Name = "Second thread";
            thread2.Priority = ThreadPriority.Lowest;
            thread2.Start();

            Thread thread3 = new Thread(() => PrintWithName("Third", 6));
            thread3.Name = "Third thread";
            thread3.Priority = ThreadPriority.Highest;
            thread3.Start();

            Thread thread4 = new Thread(() => PrintWithName("fourth", 5));
            thread4.Name = "Fourth thread";
            thread3.Priority = ThreadPriority.BelowNormal;
            thread4.Start();

            thread1.Join();
            thread2.Join();
            thread3.Join();
            thread4.Join();
            Console.WriteLine("This is it!");
        }

        private static void Main4ThreadsMessage()
        {
            Thread thread1 = new Thread(() => Print("first"));
            thread1.Start();

            Thread thread2 = new Thread(() => Print("second"));
            thread2.Start();

            Thread thread3 = new Thread(() => Print("Third"));
            thread3.Start();

            Thread thread4 = new Thread(() => Print("fourth"));
            thread4.Start();
        }

        private static void Main4ThreadsMessageNumberOfTimes()
        {
            Thread thread1 = new Thread(() => Print("first", 4));
            thread1.Start();

            Thread thread2 = new Thread(() => Print("second", 10));
            thread2.Start();

            Thread thread3 = new Thread(() => Print("Third", 6));
            thread3.Start();

            Thread thread4 = new Thread(() => Print("fourth", 5));
            thread4.Start();
        }

        private static void Main4Threads()
        {
            Thread thread1 = new Thread(Print);
            thread1.Start();

            Thread thread2 = new Thread(Print);
            thread2.Start();

            Thread thread3 = new Thread(Print);
            thread3.Start();

            Thread thread4 = new Thread(Print);
            thread4.Start();
        }

        private static void MainSimplest()
        {
            Print();
        }

        private static void Print()
        {
            for (int i = 0; i < 10; i++)
            {
                Console.WriteLine("hello world");
            }
        }

        private static void Print(String message)
        {
            for (int i = 0; i < 10; i++)
            {
                Console.WriteLine(message);
            }
        }

        private static void Print(String message, int numberOfTimes)
        {
            for (int i = 0; i < numberOfTimes; i++)
            {
                Console.WriteLine(message);
            }
        }

        private static void PrintWithName(String message, int numberOfTimes)
        {
            String nameOfThread = Thread.CurrentThread.Name;
            ThreadPriority priority = Thread.CurrentThread.Priority;
            for (int i = 0; i < numberOfTimes; i++)
            {
                Console.WriteLine(message + " : " + nameOfThread + " : " + priority);
                Thread.Sleep(10);
            }
        }
    }
}
